

#define BRAKEVCC 0
#define CW   1
#define CCW  2
#define BRAKEGND 3
#define CS_THRESHOLD 100

int inApin[2] = {7, 4};  // INA: Clockwise input
int inBpin[2] = {8, 9}; // INB: Counter-clockwise input
int pwmpin[2] = {5, 6}; // PWM input
int cspin[2] = {2, 3}; // CS: Current sense ANALOG input
int enpin[2] = {0, 1}; // EN: Status of switches output (Analog pin)
int statpin = 13;


void setup()
{
  Serial.begin(115200);
  pinMode(statpin, OUTPUT);

  // Initialize digital pins as outputs
  for (int i=0; i<2; i++)
  {
   pinMode(inApin[i], OUTPUT);
   pinMode(inBpin[i], OUTPUT);
   pinMode(pwmpin[i], OUTPUT);
   pinMode(pwmpin[i], 0);
   analogWrite(pwmpin[i], 0);
  }

  // Initialize braked
  for (int i=0; i<2; i++)
  {
   digitalWrite(inApin[i], LOW);
   digitalWrite(inBpin[i], LOW);
  }

// Make sure the motors wake up in off state
motorOff(0);
motorOff(1);
}

void loop()
{
//TCCR0B = TCCR0B & B11111000 | B00000001;    // set timer 0 divisor to     1 for PWM frequency of 62500.00 Hz
  TCCR0B = TCCR0B & B11111000 | B00000010;    // set timer 0 divisor to     8 for PWM frequency of  7812.50 Hz

  if (Serial.available())
  { 
    uint8_t Speed=Serial.read();
    if(Speed>0)
    {       
      motorGo(0, CW, Speed);        
      motorGo(1, CW, Speed);      
    }
    else if(Speed==0) 
    {
      motorOff(0);
      motorOff(1);
    }
  }
}

void motorOff(int motor)
{
  digitalWrite(inApin[motor], LOW);
  digitalWrite(inBpin[motor], LOW);
  analogWrite(pwmpin[motor], 0);
}
      
void motorGo(uint8_t motor, uint8_t direct, uint8_t Speed)
{
  if (motor <= 1)
  {
    if (direct <=4)
    {
      // Set inA[motor]
      if (direct <=1) digitalWrite(inApin[motor], HIGH);
      else digitalWrite(inApin[motor], LOW);
      
      // Set inB[motor]
      if ((direct==0)||(direct==2)) digitalWrite(inBpin[motor], HIGH);
      else digitalWrite(inBpin[motor], LOW);
      
      analogWrite(pwmpin[motor], Speed);
    }
  }
}
